
JSB.newAddon = function (mainPath) {
  JSB.require('webviewController');
  var temSender;
  var MNStyleClass = JSB.defineClass(
    'MNAutoStyle : JSExtension',
    { /* Instance members */
      sceneWillConnect: function () { //Window initialize
        self.appInstance = Application.sharedInstance();
        self.addonController = styleController.new();
        self.addonController.mainPath = mainPath;
        self.isNewWindow = false;
        self.watchMode = false;
        self.textSelected = ""
        self.textProcessed = false;
        self.dateGetText = Date.now();
        self.dateNow = Date.now();
        self.rect = '{{0, 0}, {10, 10}}';
        self.arrow = 1;
        self.isFirst = true
        // Application.sharedInstance().showHUD(self.addonController.appearOnNewExcerpt,self.window,2)

        // NSNotificationCenter.defaultCenter().addObserverSelectorName(self, 'trst:', 'onReciveTrst');
        // NSNotificationCenter.defaultCenter().addObserverSelectorName(self, 'onClosePopupMenuOnSelection:', 'ClosePopupMenuOnSelection');
      },

      sceneDidDisconnect: function () { // Window disconnect

      },

      sceneWillResignActive: function () { // Window resign active
      },

      sceneDidBecomeActive: function () { // Window become active
      },

      notebookWillOpen: function (notebookid) {
        if (self.appInstance.studyController(self.window).studyMode < 3) {
          self.appInstance.studyController(self.window).refreshAddonCommands();
          self.appInstance.studyController(self.window).view.addSubview(self.addonController.view);
          self.addonController.view.hidden = true;
          self.addonController.notebookid = notebookid
          self.notebookid = notebookid
          if (self.lastFrame) {
            
            self.addonController.view.frame = self.lastFrame
            self.addonController.currentFrame = self.lastFrame
          }
          // NSNotificationCenter.defaultCenter().addObserverSelectorName(self, 'onProcessNewExcerpt:', 'ProcessNewExcerpt');
          }
          NSTimer.scheduledTimerWithTimeInterval(0.2, false, function () {
            self.appInstance.studyController(self.window).becomeFirstResponder(); //For dismiss keyboard on iOS
          });
      },

      notebookWillClose: function (notebookid) {
        self.lastFrame = self.addonController.view.frame
        // NSNotificationCenter.defaultCenter().removeObserverName(self, 'ProcessNewExcerpt');
      },

      documentDidOpen: function (docmd5) {
      },

      documentWillClose: function (docmd5) {
      },

      controllerWillLayoutSubviews: function (controller) {
        if (controller !== self.appInstance.studyController(self.window)) {
          return;
        };
        if (!self.addonController.view.hidden) {
          let splitLine = getSplitLine()
          let studyFrame = Application.sharedInstance().studyController(this.window).view.bounds
          let currentFrame = self.addonController.currentFrame
          if (currentFrame.x+currentFrame.width*0.5 >= studyFrame.width) {
            currentFrame.x = studyFrame.width-currentFrame.width*0.5              
          }
          if (currentFrame.y >= studyFrame.height) {
            currentFrame.y = studyFrame.height-20              
          }
          if (self.addonController.splitMode) {
            // Application.sharedInstance().showHUD("useDefault",self.window,2)

            currentFrame.x = splitLine-20
          }
          self.addonController.view.frame = currentFrame
          self.addonController.currentFrame = currentFrame
        }
      },

      queryAddonCommandStatus: function () {
        if (self.appInstance.studyController(self.window).studyMode < 3) {
          return {
            image: 'logo.png',
            object: self,
            selector: 'toggleAddon:',
            checked: false
          };
        } else {
          return null;
        }
      },
      onProcessNewExcerpt:function (sender) {
        if (!self.appInstance.checkNotifySenderInWindow(sender, self.window)) return; // Don't process message from other window
        let note = Database.sharedInstance().getNoteById(sender.userInfo.noteid)
        let fillIndex
        if (note.excerptPic) {
          fillIndex = self.addonController.imagePattern[note.colorIndex]
        }else{
          fillIndex = self.addonController.textPattern[note.colorIndex]
        }
        if (fillIndex !== -1) {
          note.fillIndex = fillIndex
        }
        Application.sharedInstance().refreshAfterDBChanged(self.notebookid)
        self.addonController.autoAction(note)
      },
      toggleAddon:function (sender) {
        if (!self.addonBar) {
          self.addonBar = sender.superview.superview
          self.addonController.addonBar = self.addonBar
        }
        if (self.isFirst) {
          // Application.sharedInstance().showHUD("first",self.window,2)
          let buttonFrame = self.addonBar.frame
          // self.addonController.moveButton.hidden = true
          if (buttonFrame.x === 0) {
            self.addonController.view.frame = {x:40,y:buttonFrame.y,width:40,height:290}
          }else{
            self.addonController.view.frame = {x:buttonFrame.x-40,y:buttonFrame.y,width:40,height:290}
          }
          self.addonController.currentFrame = self.addonController.view.frame
          self.isFirst = false;
        }
        if (self.addonController.view.hidden) {
          // showHUD(JSON.stringify(self.addonBar.frame))
          self.addonController.show(self.addonBar.frame)
        }else{
          self.addonController.hide(self.addonBar.frame)
        }
      // self.addonController.view.hidden = !self.addonController.view.hidden
      }
    },
    { /* Class members */
      addonDidConnect: function () {
      },

      addonWillDisconnect: function () {
        // NSUserDefaults.standardUserDefaults().removeObjectForKey("MNAutoStyle")
      },

      applicationWillEnterForeground: function () {
      },

      applicationDidEnterBackground: function () {
      },

      applicationDidReceiveLocalNotification: function (notify) {
      }
    }
  );
  return MNStyleClass;
};